//----------------------------------------------------------------
//
// OpenDCC
// Throttle MFT 1.0
//
// Copyright (c) 2008-2009 Wolfgang Kufer
//
// This source file is subject of the GNU general public license 2,
// that is available at the world-wide-web at
// http://www.gnu.org/licenses/gpl.txt
//
//-----------------------------------------------------------------
//
// file:      ks0073_charset.h
// author:    Wolfgang Kufer
// contact:   kufer_at_gmx.de
// webpage:   http://www.opendcc.de
// history:   2008-12-08 V0.01 started
//            2009-06-30 V0.02 kw added Xi and Psi
//
//-----------------------------------------------------------------
//
// purpose:   this file defines aliases for special chars on a
//            KS0073 controller
//
//-----------------------------------------------------------------
// Source: http://www.lcd-module.de, EA-DIP204-4.pdf

#if (DISPLAY == LCD_EA204)

#define C_ARROW_R_FULL      0x10   //    right arrow >
#define C_ARROW_L_FULL      0x11   //    left arrow <
#define C_ARROW_UPUP        0x12   //    up arrow double
#define C_ARROW_DOWNDOWN    0x13   //    down arrow double
#define C_ARROW_L_LIGHT     0x14   // *: left arrow >>
#define C_ARROW_R_LIGHT     0x15   // *  right arrow <<

#define C_ARROW_LEFT_UP     0x16   // *: arrow left up (135)
#define C_ARROW_RIGHT_UP    0x17   // *: arrow right up (45)
#define C_ARROW_LEFT_DOWN   0x18   // *: arrow left down (225)
#define C_ARROW_RIGHT_DOWN  0x19   // *: arrow right down (315)


//#define C_ARROW_UP_FULL     0x1A   // up arrow full
//#define C_ARROW_DOWN_FULL   0x1B   // down arrow full

#define C_ARROW_UP_LIGHT    0x1D   // up arrow light
#define C_ARROW_DOWN_LIGHT  0x1E   // down arrow light
#define C_BLOCK_FULL        0x1F

#define C_NUM_EXP_0         0x80   // small upper 0
#define C_NUM_EXP_1         0x81   // small upper 1
#define C_NUM_EXP_2         0x82   // small upper 2
#define C_NUM_EXP_3         0x83   // small upper 3
#define C_NUM_EXP_4         0x84   // small upper 4
#define C_NUM_EXP_5         0x85   // small upper 5
#define C_NUM_EXP_6         0x86   // small upper 6
#define C_NUM_EXP_7         0x87   // small upper 7
#define C_NUM_EXP_8         0x88   // small upper 8
#define C_NUM_EXP_9         0x89   // small upper 9

#define C_DOLLAR            0xA2   // $ (strange! but correct code)

#define C_PSI               0xB7   // greek Psi
#define C_ARROW_UP_DOWN     0xB9
#define C_XI                0xBA   // greek Xi
#define C_BULLET            0xBB

#define C_BLOCK_M0          0xD0   // large
#define C_BLOCK_M1          0xD1   // 
#define C_BLOCK_M2          0xD2   // medium, used for digit
#define C_BLOCK_M3          0xD3   // 
#define C_BLOCK_M4          0xD4   // small
#define C_BLOCK_SMALL       0xDD   // used for light off

#define C_ARROW_UP_SMALL    0xDE   // |
#define C_ARROW_RIGHT_SMALL 0xDF   // |
#define C_ARROW_DOWN_SMALL  0xE0   // |
#define C_ARROW_LEFT_SMALL  0xE1   // |


#define C_SQ_BRAQ_OPEN      0xFA   // [
#define C_SQ_BRAQ_CLOSE     0xFC   // ]

#define C_VERT_LINE         0xFE   // |
#define C_BACKSLASH         0xFB   //


// 0x20 ... ASCII

#elif (DISPLAY == LCD_EA128x64)

// Char Defines for font extention to font5x7.h

#define C_BLOCK_SMALL       0x0B   // used for light off
#define C_BLOCK_M2          0x0C   // medium, used for digit

#define C_ARROW_L_LIGHT     0x14   // *: left arrow >>
#define C_ARROW_R_LIGHT     0x15   // *  right arrow <<

#define C_ARROW_LEFT_UP     0x16   // *: arrow left up (135)
#define C_ARROW_RIGHT_UP    0x17   // *: arrow right up (45)
#define C_ARROW_LEFT_DOWN   0x18   // *: arrow left down (225)
#define C_ARROW_RIGHT_DOWN  0x19   // *: arrow right down (315)

#define C_ARROW_UP_SMALL    0x1A   // |
#define C_ARROW_RIGHT_SMALL 0x1B   // |
#define C_ARROW_DOWN_SMALL  0x1C   // |
#define C_ARROW_LEFT_SMALL  0x1D   // |

#define C_ARROW_UP_DOWN     0x1E

#define C_NUM_EXP_1         0x01   // small upper 1
#define C_NUM_EXP_2         0x02   // small upper 2
#define C_NUM_EXP_3         0x03   // small upper 3
#define C_NUM_EXP_4         0x04   // small upper 4
#define C_NUM_EXP_5         0x05   // small upper 5
#define C_NUM_EXP_6         0x06   // small upper 6
#define C_NUM_EXP_7         0x07   // small upper 7
#define C_NUM_EXP_8         0x08   // small upper 8
#define C_NUM_EXP_9         0x09   // small upper 9
#define C_NUM_EXP_0         0x0A   // small upper 0

#define C_SQ_BRAQ_OPEN      0x5B   // [
#define C_SQ_BRAQ_CLOSE     0x5D   // ]

#define C_BACKSLASH         0x5C

#define C_DOLLAR            0x24   // $ (here as usual)

#else
 #warning No char defines
#endif // (DISPLAY == LCD_EA204)

