//----------------------------------------------------------------
//
// OpenDCC
// Throttle MFT 1.0
//
// Copyright (c) 2008-2009 Wolfgang Kufer
//
// This source file is subject of the GNU general public license 2,
// that is available at the world-wide-web at
// http://www.gnu.org/licenses/gpl.txt
//
//-----------------------------------------------------------------
//
// file:      menu_navigator.h
// author:    Wolfgang Kufer
// contact:   kufer@gmx.de
// webpage:   http://www.opendcc.de
// history:   2008-12-08 V0.01 started
//
//-----------------------------------------------------------------
//
// purpose:   simple menu system
//
//-----------------------------------------------------------------

// Whenever we call a menu screen, it gets an opcode and the keystroke
// These are combined in a t_navicode
//
// Opcodes (menucode):
#define MENU_OPEN           1       // call for the first time, menu
                                    // must init the screen
#define MENU_UPDATE         2       // should process the keystroke     
#define MENU_CLOSE          3       // should terminate

// Menu-IDs
typedef enum {  SCREEN_MODE,        // Mode selection
                SCREEN_LOK,         // drive
                SCREEN_WEICHE,      // turnouts
                SCREEN_EXTACC,      // extended accessory
                SCREEN_CV,          // prog
                SCREEN_CV29,        // prog CV29
                SCREEN_CV_ADDR,     // prog Address
                SCREEN_CS_CFG,      // configure command station
                SCREEN_SETUP,       // config
                SCREEN_CLOCK,       // set clock
                SCREEN_SYSSTAT,     // debug and status screen
                SCREEN_ABOUT,       // copyright notice and version
                SCREEN_LOKEDIT,     // loc edit
                SCREEN_LOKLIST,     // loc sort
                SCREEN_LOKMOVE,     // loc sort
                SCREEN_LOKRECV,     // loc receive
                SCREEN_FEEDBACK,    // feedback monitor
                SCREEN_REMOTE,      // pc screen
                #if (DREHSCHEIBE == 1) 
                SCREEN_DREH,        // turntable menu
                #endif
              } t_screen_id;

typedef struct                      // this is parameter passed along for menus
  {
    unsigned char key;              // keystroke
    unsigned char menucode;         // open, update, close
  }
  t_navicode;


typedef struct                      // definition base element for navigation
  {
    unsigned char key;
    t_screen_id index_of_target_screen;
  }
  t_navigate;


typedef void (*Ptr_To_Function)(t_navicode par);


// Variables

unsigned char actual_screen;

unsigned char last_key;             // this is the last key in history

signed int last_key_time;





// Calls

signed int run_navigator(void);           // to be run on keystrokes
void init_navigator(void);


// 
void show_splash_mft(void);
