//------------------------------------------------------------------------------
//
// OpenDCC - WRP Wireless Railroad Protocol
//
// Copyright (c) 2009,2010 Kufer
//
// This source file is subject of the GNU general public license 2,
// that is available at the world-wide-web at
// http://www.gnu.org/licenses/gpl.txt
//
//------------------------------------------------------------------------------
//
// file:      wrp_messages.h
// author:    Wolfgang Kufer
// contact:   kufer@gmx.de
// history:   2010-02-10 V0.01 kw  started
//
//------------------------------------------------------------------------------
//
// purpose:   throttle / gateway
// content:   handling of messages in a client
//
//------------------------------------------------------------------------------

// Messages we can send to base station
// used connection: WRP

#include "config.h"
#include "xbee_if.h"

// --------------------------------------------------------------------------------  basic


void wrp_transmit(void);                // send all messages accumulated so far

void wrp_send_sys_idle(void);

void wrp_send_sys_apply(void);

// --------------------------------------------------------------------------------  command station

void wrp_send_state(t_status new_state);

void wrp_send_cs_status_request(void);

void wrp_send_clock_set(t_fast_clock *my_clock);

void wrp_send_cs_cfg_read(unsigned int cv);         // command station config

void wrp_send_cs_cfg_write(unsigned int cv, unsigned char value);


// --------------------------------------------------------------------------------  loc

void wrp_send_askforlocinfo(unsigned int addr);

void wrp_send_loc_drive(unsigned int addr, t_format format, unsigned char speed, unsigned char dir);

void wrp_send_loc_control(locomem_t *loco);

void wrp_send_loc_light(void);           // sends current_loc ***

void wrp_send_loc_function(void);        // sends current_loc (all functions)

void wrp_send_loc_stop(unsigned int addr);  // nothalt

// --------------------------------------------------------------------------------- acc

void wrp_send_accessory(unsigned int addr, bool activate);

void wrp_send_accessory_query(unsigned int addr);

void wrp_clear_accessory_watch(unsigned int addr);

void wrp_send_extended_accessory(unsigned int addr, unsigned char aspect);

// --------------------------------------------------------------------------------- feedback

void wrp_send_feedback_query(unsigned int addr);

void wrp_send_feedback_subscribe(void);

// --------------------------------------------------------------------------------- programming

void wrp_send_askforresult(void);

void wrp_send_cv_read(unsigned int cv);

void wrp_send_cv_write(unsigned int cv, unsigned char value);

void wrp_send_PoM_cv_read(unsigned int addr, unsigned int cv);

void wrp_send_PoM_cv_write(unsigned int addr, unsigned int cv, unsigned char value);
