//========================================================================
// upstream interface (howto):
//
// to send something on xpressnet:
//   a) create message to be sent
//      (this must include header and data, the xor checksum
//      is calculated here)
//   b) copy this message to xp_tx_msg   or
//   c) then set xp_tx_msg_ready to 1.
//   d) if xp_tx_msg_ready is 0 again - the message is sent
//      (at least will be sent soon)
//
// or:
//   b) put the message to xp_buf_out fifo
//
//
// to receive a message:
//   a) all incoming messages are forwarded to Rx_Fifo
//   b) see xp_client_parser for processing
//
// init:
//   a) be sure to set up timer correctly
//   b) define the usart and direction port
//   c) define your desired slot_mode and slot_id.
//   d) call init_xpressnet_client();
//
// run_time:
//   a) periodically call run_xpressnet_client();
//      this updates slot_id and states
//
//========================================================================

void init_xpressnet_client(void);


t_cr_task run_xpressnet_client(void);
