//----------------------------------------------------------------
//
// OpenDCC
//
// Copyright (c) 2009 Kufer
//
// This source file is subject of the GNU general public license 2,
// that is available at the world-wide-web at
// http://www.gnu.org/licenses/gpl.txt
//
//-----------------------------------------------------------------
//
// file:      xp_messages.h
// author:    Wolfgang Kufer, Jean Michel Fischer
// contact:   kufer@gmx.de
// history:   2008-02-10 V0.01 kw  started
//            2009-03-20 V0.02 kw  restart_xpressnet_client added
//
//--------------------------------------------------------------------------
//
// purpose:   throttle
// content:   handling of messages towards xpressnet
//
//--------------------------------------------------------------------------

void restart_xpressnet_client(void);

//--------------------------------------------------------------------------

void xp_send_cs_status_request(void);

void xp_send_state(t_status new_state);

void xp_send_feedback_query(unsigned int addr);

// parameter: raw coil addr (not turnout)
void xp_send_accessory(unsigned int addr, bool activate);

// parameter: turnout addr
void xp_send_accessory_query(unsigned int addr);

void xp_send_extended_accessory(unsigned int addr, unsigned char aspect);

void xp_send_loc_stop(unsigned int addr);

void xp_send_loc_drive(unsigned int addr, t_format format, unsigned char speed, unsigned char dir);

void xp_send_loc_function(unsigned char fnum);   // works on current_loc

void xp_send_loc_light(void);

void xp_send_askforlocinfo(unsigned int addr);

void xp_send_cv_read(unsigned int cv);

void xp_send_cv_write(unsigned int cv, unsigned char value);

void xp_send_askforresult(void);

void xp_send_PoM_cv_read(unsigned int addr, unsigned int cv);

void xp_send_PoM_cv_write(unsigned int addr, unsigned int cv, unsigned char value);

void xp_send_PoM_acc_cv_read(unsigned int addr, unsigned int cv);

void xp_send_PoM_acc_cv_write(unsigned int addr, unsigned int cv, unsigned char value);

void xp_send_PoM_extacc_cv_read(unsigned int addr, unsigned int cv);

void xp_send_PoM_extacc_cv_write(unsigned int addr, unsigned int cv, unsigned char value);

// cs config
void xp_send_cs_cfg_read(unsigned int cv);

void xp_send_cs_cfg_write(unsigned int cv, unsigned char value);

void xp_send_clock_set(t_fast_clock *my_clock);

// special functions for direct pc interaction

void xp_send_pc_hello(void);

void xp_send_pc_goodbye(void);

void xp_send_PID(void);

void xp_send_pc_key(unsigned char key, signed char value);
